<script setup>

import InputTag from "@/components/tags/InputTag.vue";
import ButtonTag from "@/components/tags/ButtonTag.vue";
import {computed, ref} from "vue";
import {useFetchCategorys} from "@/stores/models/category/getCategory";
import {useChangeCategory} from "@/stores/models/category/changeCategory";
import {useRemoveCategory} from "@/stores/models/category/removeCategory";

let isChange = ref(false)
let id = ref()
let categoryName = ref('')
const categories = computed(() => useFetchCategorys().getCategories)

function change() {
    useChangeCategory().putCategory(id.value, {name: categoryName.value})
        .then(() => {
            useFetchCategorys().fetchCategorys()
            isChange.value = false
        })
}

function remove(id) {
    useRemoveCategory().deleteCategory(id)
        .then(() => {
            useFetchCategorys().fetchCategorys()
        })
}
</script>

<template>
    <div style="min-height: 70vh">
        <div class="row">
            <div v-if="isChange" class="col-12 col-md-6">
                <InputTag v-model="categoryName" id="categoryName" label-name="Kategoriya nomi"/>
                <button-tag @click="change" text="O'zgartirish" class="btn-success"/>
            </div>
            <table v-else class="table border">
                <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Kategoriya nomi</th>
                    <th scope="col">O'zgartirish</th>
                    <th scope="col">O'chirish</th>
                </tr>
                </thead>
                <tbody>
                <tr v-for="category in categories" :key="category.id">
                    <th>{{category.id}}</th>
                    <td>{{category.name}}</td>
                    <td>
                        <span
                            @click="isChange = true; id = category.id; categoryName = category.name"
                            class="cursor text-success">Change</span>
                    </td>
                    <td>
                        <span @click="remove(category.id)" class="cursor text-danger">Delete</span>
                    </td>
                </tr>
                </tbody>
            </table>
        </div>
    </div>
</template>

<style scoped>
.cursor {
    cursor: pointer;
}
</style>